#!/usr/bin/env bash

GIT_URL="https://git.autonomic.zone/coop-cloud/"
ABRA_DIR="$HOME/.abra"

#######################################
# Global help
#######################################

DOC="
The cooperative cloud utility belt 🎩🐇

Usage:
  abra [options] app new [--server=<server> --domain=<domain>] <app>
  abra [options] app (list|ls)
  abra [options] app <domain> deploy
  abra [options] app <domain> undeploy
  abra [options] app <domain> (delete|rm) [--force]
  abra [options] app <domain> logs [<service>]
  abra [options] app <domain> multilogs
  abra [options] app <domain> cp <src> <dst>
  abra [options] app <domain> run [--user=<user>] <service> <args>...
  abra [options] app <domain> run <service> <args>...
  abra [options] app <domain> secret auto
  abra [options] app <domain> secret generate <secret> <version> [<cmd>]
  abra [options] app <domain> secret insert <secret> <version> <data>
  abra [options] server add <host> [<user>] [<port>]
  abra [options] server (list|ls)
  abra [options] server rm <host>
  abra [options] server use <host>
  abra [options] server init <host>
  abra [options] upgrade
  abra [options] <command> <args>...

Options:
  -e, --env=<path>     Environment variables to load
  -h, --help           Show this message and exit
  -s, --stack=<path>   Name of the target stack
  -v, --version        Show program version

See 'abra help <command>' to read about a specific subcommand.
"

# docopt parser below, refresh this parser with `docopt.sh abra`
# shellcheck disable=2016,1075,2154
docopt() { parse() { if ${DOCOPT_DOC_CHECK:-true}; then local doc_hash
if doc_hash=$(printf "%s" "$DOC" | (sha256sum 2>/dev/null || shasum -a 256)); then
if [[ ${doc_hash:0:5} != "$digest" ]]; then
stderr "The current usage doc (${doc_hash:0:5}) does not match \
what the parser was generated with (${digest})
Run \`docopt.sh\` to refresh the parser."; _return 70; fi; fi; fi
local root_idx=$1; shift; argv=("$@"); parsed_params=(); parsed_values=()
left=(); testdepth=0; local arg; while [[ ${#argv[@]} -gt 0 ]]; do
if [[ ${argv[0]} = "--" ]]; then for arg in "${argv[@]}"; do
parsed_params+=('a'); parsed_values+=("$arg"); done; break
elif [[ ${argv[0]} = --* ]]; then parse_long
elif [[ ${argv[0]} = -* && ${argv[0]} != "-" ]]; then parse_shorts
elif ${DOCOPT_OPTIONS_FIRST:-false}; then for arg in "${argv[@]}"; do
parsed_params+=('a'); parsed_values+=("$arg"); done; break; else
parsed_params+=('a'); parsed_values+=("${argv[0]}"); argv=("${argv[@]:1}"); fi
done; local idx; if ${DOCOPT_ADD_HELP:-true}; then
for idx in "${parsed_params[@]}"; do [[ $idx = 'a' ]] && continue
if [[ ${shorts[$idx]} = "-h" || ${longs[$idx]} = "--help" ]]; then
stdout "$trimmed_doc"; _return 0; fi; done; fi
if [[ ${DOCOPT_PROGRAM_VERSION:-false} != 'false' ]]; then
for idx in "${parsed_params[@]}"; do [[ $idx = 'a' ]] && continue
if [[ ${longs[$idx]} = "--version" ]]; then stdout "$DOCOPT_PROGRAM_VERSION"
_return 0; fi; done; fi; local i=0; while [[ $i -lt ${#parsed_params[@]} ]]; do
left+=("$i"); ((i++)) || true; done
if ! required "$root_idx" || [ ${#left[@]} -gt 0 ]; then error; fi; return 0; }
parse_shorts() { local token=${argv[0]}; local value; argv=("${argv[@]:1}")
[[ $token = -* && $token != --* ]] || _return 88; local remaining=${token#-}
while [[ -n $remaining ]]; do local short="-${remaining:0:1}"
remaining="${remaining:1}"; local i=0; local similar=(); local match=false
for o in "${shorts[@]}"; do if [[ $o = "$short" ]]; then similar+=("$short")
[[ $match = false ]] && match=$i; fi; ((i++)) || true; done
if [[ ${#similar[@]} -gt 1 ]]; then
error "${short} is specified ambiguously ${#similar[@]} times"
elif [[ ${#similar[@]} -lt 1 ]]; then match=${#shorts[@]}; value=true
shorts+=("$short"); longs+=(''); argcounts+=(0); else value=false
if [[ ${argcounts[$match]} -ne 0 ]]; then if [[ $remaining = '' ]]; then
if [[ ${#argv[@]} -eq 0 || ${argv[0]} = '--' ]]; then
error "${short} requires argument"; fi; value=${argv[0]}; argv=("${argv[@]:1}")
else value=$remaining; remaining=''; fi; fi; if [[ $value = false ]]; then
value=true; fi; fi; parsed_params+=("$match"); parsed_values+=("$value"); done
}; parse_long() { local token=${argv[0]}; local long=${token%%=*}
local value=${token#*=}; local argcount; argv=("${argv[@]:1}")
[[ $token = --* ]] || _return 88; if [[ $token = *=* ]]; then eq='='; else eq=''
value=false; fi; local i=0; local similar=(); local match=false
for o in "${longs[@]}"; do if [[ $o = "$long" ]]; then similar+=("$long")
[[ $match = false ]] && match=$i; fi; ((i++)) || true; done
if [[ $match = false ]]; then i=0; for o in "${longs[@]}"; do
if [[ $o = $long* ]]; then similar+=("$long"); [[ $match = false ]] && match=$i
fi; ((i++)) || true; done; fi; if [[ ${#similar[@]} -gt 1 ]]; then
error "${long} is not a unique prefix: ${similar[*]}?"
elif [[ ${#similar[@]} -lt 1 ]]; then
[[ $eq = '=' ]] && argcount=1 || argcount=0; match=${#shorts[@]}
[[ $argcount -eq 0 ]] && value=true; shorts+=(''); longs+=("$long")
argcounts+=("$argcount"); else if [[ ${argcounts[$match]} -eq 0 ]]; then
if [[ $value != false ]]; then
error "${longs[$match]} must not have an argument"; fi
elif [[ $value = false ]]; then
if [[ ${#argv[@]} -eq 0 || ${argv[0]} = '--' ]]; then
error "${long} requires argument"; fi; value=${argv[0]}; argv=("${argv[@]:1}")
fi; if [[ $value = false ]]; then value=true; fi; fi; parsed_params+=("$match")
parsed_values+=("$value"); }; required() { local initial_left=("${left[@]}")
local node_idx; ((testdepth++)) || true; for node_idx in "$@"; do
if ! "node_$node_idx"; then left=("${initial_left[@]}"); ((testdepth--)) || true
return 1; fi; done; if [[ $((--testdepth)) -eq 0 ]]; then
left=("${initial_left[@]}"); for node_idx in "$@"; do "node_$node_idx"; done; fi
return 0; }; either() { local initial_left=("${left[@]}"); local best_match_idx
local match_count; local node_idx; ((testdepth++)) || true
for node_idx in "$@"; do if "node_$node_idx"; then
if [[ -z $match_count || ${#left[@]} -lt $match_count ]]; then
best_match_idx=$node_idx; match_count=${#left[@]}; fi; fi
left=("${initial_left[@]}"); done; ((testdepth--)) || true
if [[ -n $best_match_idx ]]; then "node_$best_match_idx"; return 0; fi
left=("${initial_left[@]}"); return 1; }; optional() { local node_idx
for node_idx in "$@"; do "node_$node_idx"; done; return 0; }; oneormore() {
local i=0; local prev=${#left[@]}; while "node_$1"; do ((i++)) || true
[[ $prev -eq ${#left[@]} ]] && break; prev=${#left[@]}; done
if [[ $i -ge 1 ]]; then return 0; fi; return 1; }; _command() { local i
local name=${2:-$1}; for i in "${!left[@]}"; do local l=${left[$i]}
if [[ ${parsed_params[$l]} = 'a' ]]; then
if [[ ${parsed_values[$l]} != "$name" ]]; then return 1; fi
left=("${left[@]:0:$i}" "${left[@]:((i+1))}")
[[ $testdepth -gt 0 ]] && return 0; if [[ $3 = true ]]; then
eval "((var_$1++)) || true"; else eval "var_$1=true"; fi; return 0; fi; done
return 1; }; switch() { local i; for i in "${!left[@]}"; do local l=${left[$i]}
if [[ ${parsed_params[$l]} = "$2" ]]; then
left=("${left[@]:0:$i}" "${left[@]:((i+1))}")
[[ $testdepth -gt 0 ]] && return 0; if [[ $3 = true ]]; then
eval "((var_$1++))" || true; else eval "var_$1=true"; fi; return 0; fi; done
return 1; }; value() { local i; for i in "${!left[@]}"; do local l=${left[$i]}
if [[ ${parsed_params[$l]} = "$2" ]]; then
left=("${left[@]:0:$i}" "${left[@]:((i+1))}")
[[ $testdepth -gt 0 ]] && return 0; local value
value=$(printf -- "%q" "${parsed_values[$l]}"); if [[ $3 = true ]]; then
eval "var_$1+=($value)"; else eval "var_$1=$value"; fi; return 0; fi; done
return 1; }; stdout() { printf -- "cat <<'EOM'\n%s\nEOM\n" "$1"; }; stderr() {
printf -- "cat <<'EOM' >&2\n%s\nEOM\n" "$1"; }; error() {
[[ -n $1 ]] && stderr "$1"; stderr "$usage"; _return 1; }; _return() {
printf -- "exit %d\n" "$1"; exit "$1"; }; set -e; trimmed_doc=${DOC:1:1237}
usage=${DOC:40:929}; digest=03087; shorts=(-h -s -e -v '' '' '' '')
longs=(--help --stack --env --version --server --domain --force --user)
argcounts=(0 1 1 0 1 1 0 1); node_0(){ switch __help 0; }; node_1(){
value __stack 1; }; node_2(){ value __env 2; }; node_3(){ switch __version 3; }
node_4(){ value __server 4; }; node_5(){ value __domain 5; }; node_6(){
switch __force 6; }; node_7(){ value __user 7; }; node_8(){ value _app_ a; }
node_9(){ value _domain_ a; }; node_10(){ value _service_ a; }; node_11(){
value _src_ a; }; node_12(){ value _dst_ a; }; node_13(){ value _args_ a true; }
node_14(){ value _secret_ a; }; node_15(){ value _version_ a; }; node_16(){
value _cmd_ a; }; node_17(){ value _data_ a; }; node_18(){ value _host_ a; }
node_19(){ value _user_ a; }; node_20(){ value _port_ a; }; node_21(){
value _command_ a; }; node_22(){ _command app; }; node_23(){ _command new; }
node_24(){ _command list; }; node_25(){ _command ls; }; node_26(){
_command deploy; }; node_27(){ _command undeploy; }; node_28(){ _command delete
}; node_29(){ _command rm; }; node_30(){ _command logs; }; node_31(){
_command multilogs; }; node_32(){ _command cp; }; node_33(){ _command run; }
node_34(){ _command secret; }; node_35(){ _command auto; }; node_36(){
_command generate; }; node_37(){ _command insert; }; node_38(){ _command server
}; node_39(){ _command add; }; node_40(){ _command use; }; node_41(){
_command init; }; node_42(){ _command upgrade; }; node_43(){ optional 0 1 2 3; }
node_44(){ optional 43; }; node_45(){ optional 4 5; }; node_46(){
required 44 22 23 45 8; }; node_47(){ either 24 25; }; node_48(){ required 47; }
node_49(){ required 44 22 48; }; node_50(){ required 44 22 9 26; }; node_51(){
required 44 22 9 27; }; node_52(){ either 28 29; }; node_53(){ required 52; }
node_54(){ optional 6; }; node_55(){ required 44 22 9 53 54; }; node_56(){
optional 10; }; node_57(){ required 44 22 9 30 56; }; node_58(){
required 44 22 9 31; }; node_59(){ required 44 22 9 32 11 12; }; node_60(){
optional 7; }; node_61(){ oneormore 13; }; node_62(){
required 44 22 9 33 60 10 61; }; node_63(){ required 44 22 9 33 10 61; }
node_64(){ required 44 22 9 34 35; }; node_65(){ optional 16; }; node_66(){
required 44 22 9 34 36 14 15 65; }; node_67(){ required 44 22 9 34 37 14 15 17
}; node_68(){ optional 19; }; node_69(){ optional 20; }; node_70(){
required 44 38 39 18 68 69; }; node_71(){ required 44 38 48; }; node_72(){
required 44 38 29 18; }; node_73(){ required 44 38 40 18; }; node_74(){
required 44 38 41 18; }; node_75(){ required 44 42; }; node_76(){
required 44 21 61; }; node_77(){
either 46 49 50 51 55 57 58 59 62 63 64 66 67 70 71 72 73 74 75 76; }
node_78(){ required 77; }; cat <<<' docopt_exit() {
[[ -n $1 ]] && printf "%s\n" "$1" >&2; printf "%s\n" "${DOC:40:929}" >&2; exit 1
}'; unset var___help var___stack var___env var___version var___server \
var___domain var___force var___user var__app_ var__domain_ var__service_ \
var__src_ var__dst_ var__args_ var__secret_ var__version_ var__cmd_ var__data_ \
var__host_ var__user_ var__port_ var__command_ var_app var_new var_list var_ls \
var_deploy var_undeploy var_delete var_rm var_logs var_multilogs var_cp \
var_run var_secret var_auto var_generate var_insert var_server var_add var_use \
var_init var_upgrade; parse 78 "$@"; local prefix=${DOCOPT_PREFIX:-''}
unset "${prefix}__help" "${prefix}__stack" "${prefix}__env" \
"${prefix}__version" "${prefix}__server" "${prefix}__domain" \
"${prefix}__force" "${prefix}__user" "${prefix}_app_" "${prefix}_domain_" \
"${prefix}_service_" "${prefix}_src_" "${prefix}_dst_" "${prefix}_args_" \
"${prefix}_secret_" "${prefix}_version_" "${prefix}_cmd_" "${prefix}_data_" \
"${prefix}_host_" "${prefix}_user_" "${prefix}_port_" "${prefix}_command_" \
"${prefix}app" "${prefix}new" "${prefix}list" "${prefix}ls" "${prefix}deploy" \
"${prefix}undeploy" "${prefix}delete" "${prefix}rm" "${prefix}logs" \
"${prefix}multilogs" "${prefix}cp" "${prefix}run" "${prefix}secret" \
"${prefix}auto" "${prefix}generate" "${prefix}insert" "${prefix}server" \
"${prefix}add" "${prefix}use" "${prefix}init" "${prefix}upgrade"
eval "${prefix}"'__help=${var___help:-false}'
eval "${prefix}"'__stack=${var___stack:-}'
eval "${prefix}"'__env=${var___env:-}'
eval "${prefix}"'__version=${var___version:-false}'
eval "${prefix}"'__server=${var___server:-}'
eval "${prefix}"'__domain=${var___domain:-}'
eval "${prefix}"'__force=${var___force:-false}'
eval "${prefix}"'__user=${var___user:-}'; eval "${prefix}"'_app_=${var__app_:-}'
eval "${prefix}"'_domain_=${var__domain_:-}'
eval "${prefix}"'_service_=${var__service_:-}'
eval "${prefix}"'_src_=${var__src_:-}'; eval "${prefix}"'_dst_=${var__dst_:-}'
if declare -p var__args_ >/dev/null 2>&1; then
eval "${prefix}"'_args_=("${var__args_[@]}")'; else eval "${prefix}"'_args_=()'
fi; eval "${prefix}"'_secret_=${var__secret_:-}'
eval "${prefix}"'_version_=${var__version_:-}'
eval "${prefix}"'_cmd_=${var__cmd_:-}'; eval "${prefix}"'_data_=${var__data_:-}'
eval "${prefix}"'_host_=${var__host_:-}'
eval "${prefix}"'_user_=${var__user_:-}'
eval "${prefix}"'_port_=${var__port_:-}'
eval "${prefix}"'_command_=${var__command_:-}'
eval "${prefix}"'app=${var_app:-false}'; eval "${prefix}"'new=${var_new:-false}'
eval "${prefix}"'list=${var_list:-false}'; eval "${prefix}"'ls=${var_ls:-false}'
eval "${prefix}"'deploy=${var_deploy:-false}'
eval "${prefix}"'undeploy=${var_undeploy:-false}'
eval "${prefix}"'delete=${var_delete:-false}'
eval "${prefix}"'rm=${var_rm:-false}'; eval "${prefix}"'logs=${var_logs:-false}'
eval "${prefix}"'multilogs=${var_multilogs:-false}'
eval "${prefix}"'cp=${var_cp:-false}'; eval "${prefix}"'run=${var_run:-false}'
eval "${prefix}"'secret=${var_secret:-false}'
eval "${prefix}"'auto=${var_auto:-false}'
eval "${prefix}"'generate=${var_generate:-false}'
eval "${prefix}"'insert=${var_insert:-false}'
eval "${prefix}"'server=${var_server:-false}'
eval "${prefix}"'add=${var_add:-false}'; eval "${prefix}"'use=${var_use:-false}'
eval "${prefix}"'init=${var_init:-false}'
eval "${prefix}"'upgrade=${var_upgrade:-false}'; local docopt_i=1
[[ $BASH_VERSION =~ ^4.3 ]] && docopt_i=2; for ((;docopt_i>0;docopt_i--)); do
declare -p "${prefix}__help" "${prefix}__stack" "${prefix}__env" \
"${prefix}__version" "${prefix}__server" "${prefix}__domain" \
"${prefix}__force" "${prefix}__user" "${prefix}_app_" "${prefix}_domain_" \
"${prefix}_service_" "${prefix}_src_" "${prefix}_dst_" "${prefix}_args_" \
"${prefix}_secret_" "${prefix}_version_" "${prefix}_cmd_" "${prefix}_data_" \
"${prefix}_host_" "${prefix}_user_" "${prefix}_port_" "${prefix}_command_" \
"${prefix}app" "${prefix}new" "${prefix}list" "${prefix}ls" "${prefix}deploy" \
"${prefix}undeploy" "${prefix}delete" "${prefix}rm" "${prefix}logs" \
"${prefix}multilogs" "${prefix}cp" "${prefix}run" "${prefix}secret" \
"${prefix}auto" "${prefix}generate" "${prefix}insert" "${prefix}server" \
"${prefix}add" "${prefix}use" "${prefix}init" "${prefix}upgrade"; done; }
# docopt parser above, complete command for generating this parser is `docopt.sh abra`

PROGRAM_NAME=$(basename "$0")

#######################################
# Helpers
#######################################

###### Utility functions

error() {
  echo "$(tput setaf 1)ERROR: $*$(tput sgr0)"
  exit 1
}

warning() {
  echo "$(tput setaf 3)WARNING: $*$(tput sgr0)"
}

success() {
  echo "$(tput setaf 2)$*$(tput sgr0)"
}

###### Default settings

if [ -z "$COMPOSE_FILE" ]; then
  COMPOSE_FILE="compose.yml"
fi

###### Safety checks

require_multitail() {
  if ! type multitail > /dev/null 2>&1; then
    error "multitail program is not installed"
  fi
}

require_abra_dir() {
  mkdir -p "$ABRA_DIR"
}

require_stack() {
  if [ -z "$STACK_NAME" ]; then
    error "no stack_name, export \$STACK_NAME=my_cool_app"
  fi
}

# FIXME 3wc: update or remove
if [ -z "$ABRA_ENV" ] && [ -f .envrc ] && type direnv > /dev/null 2>&1 && ! direnv status | grep -q 'Found RC allowed true'; then
  error "direnv is blocked, run direnv allow"
fi

###### Run-time loading

load_custom_commands() {
  if [ -f abra-commands.sh ]; then
    # shellcheck disable=SC1091
    source abra-commands.sh
  fi

  if [ -f "$APP_DIR/abra-commands.sh" ]; then
    # shellcheck disable=SC1090
    source "$APP_DIR/abra-commands.sh"
  fi
}

###### FIXME 3wc: name this section

get_servers() {
  shopt -s nullglob dotglob
  SERVERS=(~/.abra/servers/*)
  shopt -u nullglob dotglob
}

get_app_secrets() {
  # FIXME 3wc: requires bash 4, use for loop instead
  mapfile -t SECRETS < <(grep PASSWORD "$ENV_FILE" | cut -d' ' -f2)
}

load_instance() {
  DOMAIN="$abra__domain_"
  # FIXME 3wc: requires bash 4, use for loop instead
  mapfile -t ENV_FILES < <(find -L ~/.abra -name "$DOMAIN.env")
  case "${#ENV_FILES[@]}" in
    1 ) ;;
    0 ) error "Can't find app '$DOMAIN'"; return;;
    * ) error "Found $DOMAIN in multiple servers: ${ENV_FILES[*]}"; return;;
  esac
  ENV_FILE="${ENV_FILES[0]}"
  if [ ! -f "$ENV_FILE" ]; then
    error "Can't open ENV_FILE '$ENV_FILE'"
  fi
  IFS='/' read -r -a PARTS <<< "$ENV_FILE"
  SERVER="${PARTS[-2]}"
  export STACK_NAME="${DOMAIN//./_}"
}

load_instance_env() {
  # shellcheck disable=SC1090
  source "$ENV_FILE"
  if [ -z "$APP" ]; then
    error "APP not set, maybe $ENV_FILE is using an old format?"
  fi
  APP_DIR="$ABRA_DIR/apps/$APP"
  export DOCKER_CONTEXT="$SERVER"
  export DOMAIN
}

load_context() {
  # Load current context from env or Docker
  if [ -z "$DOCKER_CONTEXT" ]; then
    warning "\$DOCKER_CONTEXT not set, (slowly) looking it up"
    # shellcheck disable=SC2063
    DOCKER_CONTEXT=$(docker context ls | grep '*' | cut -d' ' -f1)
    # make sure grep doesn't parse this, we want a literal '*'
  fi
}

#######################################
# abra app ..
#######################################

###### .. app (list|ls)
sub_app_ls (){
  sub_app_list
}

sub_app_list (){
  shopt -s nullglob dotglob
  ENV_FILES=(~/.abra/servers/*/*.env)
  shopt -u nullglob dotglob

  printf "%s lovely apps:\n\n" "${#ENV_FILES[@]}"

  for i in "${!ENV_FILES[@]}"; do
    # Do this inside the loop to include in pipe to `column`
    if [ "$i" == 0 ]; then
      printf "  DOMAIN\tAPP\tSERVER\n  --\t--\t--\n"
    fi

    local ENV_FILE="${ENV_FILES[$i]}"

    IFS='/' read -r -a PARTS <<< "$ENV_FILE"

    FILE="${PARTS[-1]}"
    SERVER="${PARTS[-2]}"
    DOMAIN="${FILE%.env}"
    # shellcheck disable=SC1090
    APP="$(source "$ENV_FILE" && echo "$APP")"
    printf "  %s\t%s\t%s\n" "$DOMAIN" "$APP" "$SERVER"
  done | column -s'	' -t
  # Align table `-t` based on tab characters -s`^V<Tab>`
}

###### .. app new [--domain=<domain> --server=<server>]
sub_app_new (){
  require_abra_dir
  get_servers

  APP=$abra__app_
  SERVER=$abra___server
  DOMAIN=$abra___domain

  if [ -z "$SERVER" ]; then
    echo "Where would you like to put $APP?"

    echo -n "$(tput setaf 4)"
    for i in "${!SERVERS[@]}"; do
      printf " %s)\t%s\n" "$i" $(basename "${SERVERS[$i]}")
    done
    echo -n "$(tput sgr0)"

    read -rp "Choose server 0-$i, or Ctrl+C to quit: " SERVER_CHOICE

    SERVER="${SERVERS[$SERVER_CHOICE]}"
  else
    SERVER="$ABRA_DIR/servers/$SERVER"
  fi

  if [ ! -d "$SERVER" ]; then
    error "Server '$SERVER' not found"
  fi

  APP_DIR="$ABRA_DIR/apps/$APP"

  if [ ! -d "$APP_DIR" ]; then
    # FIXME 3wc: move to require_app_clone or something
    warning "'$APP' not found, fetching via git.."

    if ! git clone "$GIT_URL/$APP.git" "$ABRA_DIR/apps/$APP"; then
      error "Could not retrieve '$APP', this app doesn't exist?"
    fi

  fi

  if [ -z "$DOMAIN" ]; then
    read -rp "Domain name: " DOMAIN
  fi

  ENV_FILE="$SERVER/$DOMAIN.env"

  if [ -f "$ENV_FILE" ]; then
    error "$ENV_FILE already exists"
    # FIXME 3wc: offer to user $STACK_$DOMAIN.env name instead
  fi

  cp "$APP_DIR/.envrc.sample" "$ENV_FILE"
  sed -i "s/$APP\.example\.com/$DOMAIN/g" "$ENV_FILE"

  abra__domain_="$DOMAIN"

  get_app_secrets

  if [ "${#SECRETS[@]}" -gt 0 ]; then
    read -rp "Generate ${#SECRETS[@]} secrets? ([y]/n) " SECRETS_CONFIRM
    if [ "$SECRETS_CONFIRM" != "n" ]; then
      sub_app_secret_auto
    fi
  fi

  echo "$(tput setaf 4)Your new '$APP' is ready for action:$(tput sgr0)"
  echo "  $(tput setaf 3)Customise the configuration:"
  echo "    $ENV_FILE$(tput sgr0)"
  echo "  $(tput setaf 2)Deploy it:"
  echo "    abra app deploy $DOMAIN$(tput sgr0)"
}

###### .. app <domain> deploy
sub_app_deploy (){
  load_instance
  load_instance_env

  echo "About to deploy:"
  echo "  Server: $(tput setaf 4)${SERVER}$(tput sgr0)"
  if [ "${COMPOSE_FILE/:/}" == "${COMPOSE_FILE}" ]; then
    echo "  Compose: $(tput setaf 3)${APP_DIR}/${COMPOSE_FILE}$(tput sgr0)"
  else
    echo "  Compose: $(tput setaf 3)${APP_DIR}/"
    IFS=':' read -ra COMPOSE_FILES <<< "$COMPOSE_FILE"
    for COMPOSE in "${COMPOSE_FILES[@]}"; do
      echo "   - ${COMPOSE}"
    done
    tput sgr0
  fi
  if [ -n "$DOMAIN" ]; then
    echo "  Domain: $(tput setaf 2)${DOMAIN}$(tput sgr0)"
  fi
  echo "  Stack: $(tput setaf 1)${STACK_NAME}$(tput sgr0)"

  read -rp "Continue? (y/[n])? " choice

  case "$choice" in
    y|Y ) ;;
    n|N ) return;;
    * ) return;;
  esac

  (
    cd "$APP_DIR" || error "\$APP_DIR '$APP_DIR' not found"
    # shellcheck disable=SC2086
    if docker stack deploy -c ${COMPOSE_FILE/:/ -c } "$STACK_NAME"; then
      if [ -n "$DOMAIN" ]; then
        success "Yay! App should be available at https://${DOMAIN}"
      else
        success "Yay! That worked. No \$DOMAIN defined, check logs."
      fi
    else
      error "Oh no! Something went wrong 😕 Check errors above"
    fi
  )
}

###### .. app <domain> undeploy
sub_app_undeploy (){
  load_instance
  load_instance_env

  warning "Un-deploy $DOMAIN from $SERVER?"
  read -rp "Enter to continue, Ctrl+C to quit"

  docker stack rm "$STACK_NAME"
}

###### .. app <domain> delete
sub_app_rm (){
  sub_app_delete
}

sub_app_delete (){
  load_instance
  load_instance_env

  if [ "$abra___force" != "true" ]; then
    warning "Delete $ENV_FILE?"
    read -rp "Enter to continue, Ctrl+C to quit"
  fi

  rm "$ENV_FILE"
}

###### .. app <domain> secret insert
sub_app_secret_insert() {
  load_instance
  load_instance_env

  SECRET="$abra__secret_"
  VERSION="$abra__version_"
  PW="$abra__data_"

  if [ -z "$SECRET" ] || [ -z "$VERSION" ] || [ -z "$PW" ]; then
    error "Required arguments missing"
  fi

  echo "$PW" | docker secret create "${STACK_NAME}_${SECRET}_${VERSION}" - > /dev/null
  if type pass > /dev/null 2>&1; then
    echo "$PW" | pass insert "hosts/$DOCKER_CONTEXT/${STACK_NAME}/${SECRET}" -m > /dev/null
    success "pass: hosts/$DOCKER_CONTEXT/${STACK_NAME}/${SECRET}"
  fi
}

###### .. app <domain> secret generate
sub_app_secret_generate(){
  load_instance
  load_instance_env

  SECRET="$abra__secret_"
  VERSION="$abra__version_"
  PWGEN=${abra__cmd_:-pwgen}


  if [ -z "$SECRET" ] || [ -z "$VERSION" ]; then
    error "Required arguments missing"
  fi

  PW=$($PWGEN)

  success "Password: $PW"

  # FIXME 3wc: this is a little janky, might be better to make a
  # util_secret_insert function which this and sub_secret_insert can call
  abra__data_="$PW"

  sub_app_secret_insert
}

sub_app_secret_auto(){
  load_instance
  load_instance_env

  get_app_secrets

  for SECRET in "${SECRETS[@]}"; do
    abra__secret_="${SECRET%=*}"  # strip =v1
    abra__secret_="${abra__secret_%_VERSION}"  # strip VERSION_
    abra__secret_="${abra__secret_,,}"  # lowercase
    abra__version_="${SECRET#*=}"
    sub_app_secret_generate
  done
}

###### .. app <domain> run <args>...
sub_app_run(){
  load_instance
  load_instance_env

  if [ -n "$abra___user" ]; then
    RUN_USER="-u $abra___user"
  fi

  CONTAINER=$(docker container ls --format "table {{.ID}},{{.Names}}" \
    | grep "${STACK_NAME}_${abra__app_}" | head -n1 | cut -d',' -f1)

  if [ -z "$CONTAINER" ]; then
    error "Can't find a container for ${STACK_NAME}_${abra__service_}"
    exit
  fi

  # shellcheck disable=SC2086
  docker exec $RUN_USER -it "$CONTAINER" "$@"

  return
}

###### .. app <domain> multilogs
sub_app_multilogs() {
  # Inspired by https://github.com/moby/moby/issues/31458#issuecomment-475411564
  require_multitail

  load_instance
  load_instance_env

  # Get a list of the service names
  SERVICES=$(docker stack services --format "{{.Name}}" "${STACK_NAME}")
  # Sort the service names
  SERVICES=$(echo "${SERVICES}" | sort)
  # Create the command to run
  COMMAND='multitail --mergeall'
  for SERVICE in ${SERVICES}; do
      COMMAND="${COMMAND} -L 'docker service logs --tail 20 -f ${SERVICE}'"
  done
  # Run the command
  bash -c "${COMMAND}"
}

###### .. app <domain> logs <service> <args>...
sub_app_logs (){
  load_instance
  load_instance_env

  SERVICE="${abra__service_}"

  if [ -z "$SERVICE" ]; then
    warning "No \$SERVICE provided, running multilogs"
    sub_app_multilogs
  fi

  shift

  if [ $# -eq 0 ]; then
    LOGS_ARGS="\
    --follow \
    --tail 20 \
    --no-trunc \
    --details \
    --timestamps"
  else
    # shellcheck disable=SC2124
    LOGS_ARGS=$@
  fi

  # shellcheck disable=SC2086
  docker service logs "${STACK_NAME}_${SERVICE}" $LOGS_ARGS
}

###### .. app <domain> cp <src> <dst>
sub_app_cp() {
  load_instance
  load_instance_env

  SOURCE="${abra__src_}"
  DEST="${abra__dst_}"

  SERVICE=$(echo "$SOURCE" | grep -o '^[^:]\+:' || echo "$DEST" | grep -o '^[^:]\+:')
  SERVICE=$(echo "$SERVICE" | tr -d ':')

  if [ -z "$SERVICE" ]; then
    echo "Usage: $PROGRAM_NAME cp SERVICE:SRC_PATH DEST_PATH"
    echo "       $PROGRAM_NAME cp SRC_PATH SERVICE:DEST_PATH"
    echo ""
    error "Can't find SERVICE in either SRC or DEST"
  fi

  CONTAINER=$(docker container ls --format "table {{.ID}},{{.Names}}" \
    | grep "${STACK_NAME}_${SERVICE}" | cut -d',' -f1)

  if [ -z "$CONTAINER" ]; then
    error "Can't find a container for ${STACK_NAME}_${SERVICE}"
    exit
  fi

  CP_ARGS=$(echo "$SOURCE $DEST" | sed "s/$SERVICE:/$CONTAINER:/")

  # shellcheck disable=SC2086
  docker cp ${CP_ARGS}
}

#######################################
# abra server ..
#######################################

###### .. server ls
sub_server_ls() {
  sub_server_list
}

sub_server_list() {
  get_servers
  printf "%s servers:\n\n" "${#SERVERS[@]}"
  for SERVER in "${SERVERS[@]}"; do
    echo "  ${SERVER##*/}"
  done
}

###### .. server init <host>
sub_server_init() {
  export DOCKER_CONTEXT="${abra__host_}"

  load_context

  docker swarm init || true
  docker network create --driver=overlay proxy --scope swarm || true
}

###### .. server <add> <host> [<username>] [<password>]
sub_server_add() {
  require_abra_dir

  HOST="$abra__host_"
  USERNAME="$abra__user_"
  PORT="$abra__port_"

  if [ -n "$PORT" ]; then
    PORT=":$PORT"
  fi

  if [ -n "$USERNAME" ]; then
    USERNAME="$USERNAME@"
  fi

  docker context create "$HOST" \
    --docker "host=ssh://$USERNAME$HOST$PORT" \
    || true

  mkdir -p "$ABRA_DIR/servers/$HOST"
}

###### .. server <host> delete
sub_server_rm() {
  sub_server_delete
}
sub_server_delete() {
  docker context rm  "$abra__host_"
}

###### .. server <host> use
sub_server_use() {
  docker context use "$abra__host_"
}

#######################################
# Misc commands
#######################################

###### .. upgrade
sub_upgrade() {
  curl https://install.abra.autonomic.zone | bash
}

###### .. volume <args>...
sub_stack() {
  # shellcheck disable=SC2068
  docker stack $@
}

###### .. stack <args>...
sub_volume() {
  # shellcheck disable=SC2068
  docker volume $@
}

#######################################
# Main
#######################################

abra() {
  # TODO (3wc): we either need to do this, or add 'shellcheck disable' all over
  # the place to handle the dynamically-defined vars
  declare abra___stack abra___env abra__command_ abra__args_ \
    abra__secret_ abra__version_ abra__data_ abra___user abra__host_ \
    abra__app_ abra__port_ abra__user_ abra__service_ abra__src_ abra__dst_ \
    abra__domain_ abra___server abra___domain abra___force

  DOCOPT_PREFIX=abra_
  eval "$(docopt "$@")"

  # --stack <stack>
  STACK_NAME=$abra___stack

  # --env <env>
  if [ -n "$abra___env" ]; then
    # shellcheck disable=SC1090
    source "$abra___env" || error "Unable to load env from '$abra___env'"
  fi

  load_custom_commands

  # Search for sub_* functions, and check if any of them matches enabled
  # arguments (i.e. is a command and is specified)
  for SUBCOMMAND in $(declare -Ff | grep 'sub_' | cut -d' ' -f3 | sort -r); do
    IFS='_' read -r -a PARTS <<< "$SUBCOMMAND"
    for PART in "${PARTS[@]:1}"; do
      # TODO 3wc: probably a better way to check if a function is defined..
      VAR=$(eval "echo \$abra_$PART")
      if [ ! "$VAR" == "true" ]; then
        continue 2
      fi
    done
    abra__command_=$(IFS="_"; echo "${PARTS[*]:1}")
  done

  # Use abra__command_ in case `command` is provided (i.e. `volume` or `stack`)
  CMD="sub_${abra__command_}"
  if type "$CMD" > /dev/null 2>&1; then
    # shellcheck disable=SC2086
    "$CMD" ${abra__args_[*]}
  else
    docopt_exit
  fi
}

abra "$@"
